# Part of Set Crew Sounds
# by Sov
# License: Ask for permission to modify source code

import App
import Foundation
import MissionLib
from Custom.SetCrewSounds import SetCrewSounds

mode = Foundation.MutatorDef("Set Crew Sounds")

class SetCrewSoundsSetPlayer(Foundation.TriggerDef):
        def __init__(self, name, eventKey, dict = {}):
                Foundation.TriggerDef.__init__(self, name, eventKey, dict)

        def __call__(self, pObject, pEvent):
                SetCrewSounds.LoadSounds()
                if pObject and pEvent:
                        pObject.CallNextHandler(pEvent)

class SetCrewSoundsPlayerCreated(Foundation.TriggerDef):
        def __init__(self, name, eventKey, dict = {}):
                Foundation.TriggerDef.__init__(self, name, eventKey, dict)

        def __call__(self, pObject, pEvent):
                pPlayer = MissionLib.GetPlayer()
                pShip = App.ShipClass_Cast(pEvent.GetDestination())
                if pPlayer and pShip:
                        if pPlayer.GetObjID() == pShip.GetObjID():
                                # Trigger only if the player is created
                                SetCrewSounds.LoadSounds()
                if pObject and pEvent:
                        pObject.CallNextHandler(pEvent)						

SetCrewSoundsSetPlayer('Set Crew Sounds Set Player', App.ET_SET_PLAYER, dict = { 'modes': [ mode ] } )
SetCrewSoundsPlayerCreated('Set Crew Sounds Player Created', App.ET_OBJECT_CREATED, dict = { 'modes': [ mode ] } )						