# Part of Set Crew Sounds
# by Sov
# License: Ask for permission to modify source code

import App
import nt
import string

# Plugin directory
sDir = "scripts\\Custom\\SetCrewSounds\\Plugins"
sDir2 = "Custom.SetCrewSounds.Plugins."

# Global plugin data, loaded only once
dSoundData = {}

# Data used to restore old data
sLastActivePlugin = ""
sDefaultTGL = "data/TGL/Bridge Crew General.tgl"

def LoadSounds():
        pGame = App.Game_GetCurrentGame()
        if not pGame:
                return 0
        dSounds = GetSoundData()
        sCurrentBridge = GetCurrentBridgeScript()
        if not sCurrentBridge:
                return 0
        if dSounds.has_key(sCurrentBridge):
                SetLastActivePlugin(sCurrentBridge)
                sTGL = dSounds[sCurrentBridge][0]
                lChars = dSounds[sCurrentBridge][1]
                lSounds = dSounds[sCurrentBridge][2]
                # Setting character database, for subtitles sake
                for s in lChars:
                        pChar = GetBridgeCharacter(s)
                        if pChar:
                                pChar.SetDatabase(sTGL)
                # Will crash the game if it doesn't exist
                pDb = App.g_kLocalizationManager.Load(sTGL)		
                for s in lSounds:			
                        pGame.LoadDatabaseSoundInGroup(pDb, s, "BridgeGeneric")
                App.g_kLocalizationManager.Unload(pDb)
        else:
                # Reload default sounds
                sPlugin = GetLastActivePlugin()
                if sPlugin != "":
                        if dSoundData.has_key(sPlugin):
                                lSounds = dSounds[sPlugin][2]
                                lChars = GetAllCharacters()
                                # Setting character database, for subtitles sake
                                for s in lChars:
                                        pChar = GetBridgeCharacter(s)
                                        if pChar:
                                                pChar.SetDatabase(sDefaultTGL)   
                                # Will crash the game if it doesn't exist, although this file has to exist... unless some smartass deleted it...
                                pDb = App.g_kLocalizationManager.Load(sDefaultTGL)		
                                for s in lSounds:			
                                        pGame.LoadDatabaseSoundInGroup(pDb, s, "BridgeGeneric")
                                App.g_kLocalizationManager.Unload(pDb)                

def GetSoundData():
        global dSoundData
        if len(dSoundData) == 0:
                dSoundData = GetDataFromPlugin()
        return dSoundData

def GetBridgeCharacter(sChar):
        pSet = App.g_kSetManager.GetSet("bridge")
        if not pSet:
                return None
        pChar = App.CharacterClass_Cast(pSet.GetObject(sChar))
        if not pChar:
                return None
        
        return pChar

def GetCurrentBridgeScript():
        pSet = App.g_kSetManager.GetSet("bridge")
        if not pSet:
                return None

        pBridgeSet = App.BridgeSet_Cast(pSet)
        if not pBridgeSet:
                return None

        return pBridgeSet.GetConfig()

def SetLastActivePlugin(s):
        global sLastActivePlugin
        sLastActivePlugin = s
        
def GetLastActivePlugin():
        global sLastActivePlugin
        s = sLastActivePlugin
        sLastActivePlugin = ""
        return s

def GetAllCharacters():
        return ["Helm", "Tactical", "XO", "Science", "Engineer"]

def GetDataFromPlugin():
        dSounds = {}
        lLoaded = []
        list = nt.listdir(sDir)
        list.sort()

        for item in list:
                s = string.split(item, '.')
                if len(s) <= 1:
                        continue

                ext = s[-1]
                fileName = string.join(s[:-1], '.')
                if fileName == "__init__":
                        continue

                sModule = sDir2 + str(fileName)		
                if ext == "py" and not fileName in lLoaded:
                        lLoaded.append(fileName)
                        try:
                                pModule = __import__(sModule)
                        except:
                                continue			

                        # Checks if the plugin has all the required data
                        if hasattr(pModule, "GetTGLPath") and hasattr(pModule, "GetBridgeScript") and hasattr(pModule, "GetCharacters") and hasattr(pModule, "GetSounds"):
                                # You can't have 2 plugins for a same bridge, so no being a smartass
                                if dSounds.has_key(pModule.GetBridgeScript()):
                                        print "Set Crew Sounds plugin skipped " + str(fileName) + " because it is a duplicate"
                                else:					
                                        dSounds[pModule.GetBridgeScript()] = [pModule.GetTGLPath(), pModule.GetCharacters(), pModule.GetSounds()]
                        else:
                                print "Set Crew Sounds plugin is invalid " + str(fileName)
                                continue

        return dSounds
